/* 
 * © 2008-2009 Sun Microsystems, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _STUB_SELECTOR_H_
#define _STUB_SELECTOR_H_

#include "mforms/selector.h"

#include "stub_view.h"

namespace mforms
{
namespace stub
{

class SelectorImpl : public ViewImpl
{
 protected:
  SelectorImpl(::mforms::Selector *self, ::mforms::SelectorStyle style);
  static void __stdcall callback(::mforms::Selector *self);
  static bool __stdcall create(::mforms::Selector *self, ::mforms::SelectorStyle style);
  static void __stdcall clear(::mforms::Selector *self);
  static int __stdcall add_item(::mforms::Selector *self, const std::string &item);
  static void __stdcall add_items(::mforms::Selector *self, const std::list<std::string> &items);
  static std::string __stdcall get_item(::mforms::Selector *self, int index);
  static std::string __stdcall get_text(::mforms::Selector *self);
  static void __stdcall set_index(::mforms::Selector *self, int index);
  static int __stdcall get_index(::mforms::Selector *self);
  static int __stdcall get_item_count(::mforms::Selector *self);
  static void __stdcall set_value(::mforms::Selector *self, const std::string&);

 public:
  ~SelectorImpl();
  static void init();
};

}
}


#endif
